/* Sets up the player for custom movement controls.
*/

#include "PlayerMoveSpeed.dm"

client
	Move()

mob/player
	var
		// Should diagonal moves be the same speed as non-diagonal moves?
		normalize_movement = FALSE

		tmp
			vector2/move_input

	Login()
		..()
		move_input = Vector2.Zero
		EVENT_ADD(client.macros.OnPressed, src, .proc/UpdateMoveInput)
		EVENT_ADD(client.macros.OnReleased, src, .proc/UpdateMoveInput)

	proc
		UpdateMoveInput()
			var vector2/new_move_input = new/vector2(
				client.macros["D"] - client.macros["A"],
				client.macros["W"] - client.macros["S"])

			if(normalize_movement && new_move_input ~! Vector2.Zero)
				new_move_input = new_move_input.Normalized()

			if(new_move_input ~! move_input)
				move_input = new_move_input
				MoveInputChanged()

		MoveInputChanged()
