/* Makes the camera turn with the player.
	Try this with TankControls or SpaceshipControls.
*/

#include "AtomForward.dm"
#include "PlaneTransform.dm"

mob/player
	SetForward(vector2/new_forward)
		var matrix
			old_rotation = Forward().Rotation()
			new_rotation = new_forward.Rotation()
		..()
		animate(client.world_plane_master,
			time = 1,
			flags = ANIMATION_END_NOW | ANIMATION_PARALLEL | ANIMATION_RELATIVE,
			transform = old_rotation / new_rotation)
