/* Draw with the mouse.
*/

#include "PlayerLoop.dm"

world
	fps = 60

turf/checker
	wall_chance = 0

obj/line
	icon = 'shapes.dmi'
	icon_state = "rect"
	appearance_flags = RESET_COLOR | PIXEL_SCALE
	mouse_opacity = FALSE

mob/player
	var
		tmp
			vector2/last_mouse_position

	PlayerUpdate()
		..()
		var vector2/mouse_position = client.mouse_position.WorldPosition()
		if(client.mouse_buttons[client.MouseLeft] && last_mouse_position)
			if(last_mouse_position ~! mouse_position)
				// Reuse the same line obj and add it to the overlays of the turf it's on.
				// Compared to creating a new obj every time, this is more efficient for
				// both the server and the client that has to render each separate obj.
				var global/obj/line/Line = new
				Line.transform = line_transform(mouse_position - last_mouse_position, 2)
				Line.SetCenterTo(last_mouse_position, z)
				if(Line.loc)
					Line.transform = Line.transform.Translate(Line.step_x, Line.step_y)
					Line.loc.overlays += Line
					Line.loc = null
		last_mouse_position = mouse_position
