/* A basic setup for all demos.

	Include some files to see what they do.
	Not all of them are compatible with each other.
*/

world
	fps = 20
	maxx = 500
	maxy = 500
	view = 8
	turf = /turf/checker
	mob = /mob/player

client
	fps = 60

mob/player
	icon_state = "oval"
	maptext = " "

	Login()
		// Spawn at the center of the map
		SetCenterTo(TileWidth/2 * world.maxx, TileHeight/2 * world.maxy, 1)
		..()

turf/checker
	icon_state = "rect"

	var wall_chance = 2

	New()
		..()
		if(prob(wall_chance))
			new/turf/wall(src)
		else
			color = (x + y) & 1 ? rgb(50, 50, 50) : rgb(55, 55, 55)

turf/wall
	icon_state = "rect"
	color = rgb(30, 30, 30)
	density = TRUE
